--[[============================================================================
midi_control.lua, start/stop midi engine, process midi messages
============================================================================]]--
  
function midi_engine(MODE)

  local device_name = device_list[selected_midi_device]
  
  local midi_dumper = MidiDumper(device_name)

  if MODE == 'start' then

    if device_name ~= NO_DEVICE then
      midi_dumper:start()
      --print('dumper started', device_name)
    end

  else
    midi_dumper:stop()
  end
  

  if MODE=='start' then
    --Take care edit mode is always being turned off when learn mode
    --gets enabled. If no midi device detected, this still has to be 
    --triggered for PC keyboard mode!
    renoise.song().transport.edit_mode = false
  end

end


--------------------------------------------------------------------------------
--Midi callback function (see midi_device.lua for origination!)

function process_messages(message)
  local nr_debug = false
  local current_octave = renoise.song().transport.octave
  
--  print (message[1],message[2],message[3],message[4])
  if message[1] >= 223 and message[1] <= 239 then
    if selected_channel > 0 then
      if message[1] ~= (223+selected_channel) then
        return
      end
    end
      
    local value = message[3]
    if message[2] ~= 0 then
      pitch_bend_max_range = message[2]
    end
    if pitch_bend_max_range > 127 then
      value = (127/pitch_bend_max_range) * value
    end
    if message[3] == (pitch_bend_max_range+1)/2 then
      value = 63.5 --Bug in the Midi control device slider value? center value is not 64, pitchbend however is.
    end
    if value > 127 then
      value = 127
    end
    change_from_controller = true
      transpose_pitch_value(value)
    change_from_controller = false
      
  end

end

